const Container = require('./Container')
class DependencyInjector {
    constructor(container = new Container()) {
        this.container = container
        this.container.di = this
    }

    make(Class) {
        if ( !this.__is_injectable(Class) ) {
            throw new Error('Cannot inject non-injectable class.')
        }

        Class.__inject(this.container)
        return Class
    }

    service(name) {
        return this.container.service(name)
    }

    has(name) {
        if ( Array.isArray(name) ) {
            return name.some(x => this.container.has(x))
        }

        return this.container.has(name)
    }

    __is_injectable(Class) {
        return (
            typeof Class.__inject === 'function'
            && Class.__inject.length > 0
        )
    }
}

module.exports = exports = DependencyInjector
